-------------------------------------------------
--GUI menu
--Intent all Red addon options are here.
--WOW already had an Addon menu, spose i could migrate to that
--still gotta get it working firse.
--Thank you Mike Richards Mayron 2015 for your youtube tutorials
--

-------------------------
--Namespaces --To share across files? 'Local' is suppose to be only with in ...
-------------------------
local _, core = ...;
core.Config = {}; 
chkLimit = (3)
local Config = core.Config;
local UIConfig;

-------------------------
--Defaults
-------------------------
local defaults = {
	theme = {
		r = 0,
		b = 0.8,
		g = 1,
		hex = "00ccff"
	}
}

-------------------------
--Core Fuctions
-------------------------


function Config:Toggle()
	local menu = UIConfig or Config.CreateMenu();
	menu:SetShown(not menu:IsShown());
end

function Config:GetThemeColour()
	local c = defaults.theme;
	return c.r, c.b, c.g, c.hex;
end

function Config:CreateButton(point, relativeFrame, relativePoint, yOffset, text) 
 	local btn = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate"); 
 	btn:SetPoint(point, relativeFrame, relativePoint, 0, yOffset); 
 	btn:SetSize(140, 30); 
 	btn:SetText(text); 
 	btn:SetNormalFontObject("GameFontNormal"); 
 	return btn; 
 end



-- Main Frame
function Config.CreateMenu()
	UIConfig = CreateFrame("Frame", "AssistantRed", UIParent, "BasicFrameTemplateWithInset"); --OptionsFrameTemplate BasicFrameTemplateWithInset
	UIConfig:SetSize(260, 260); --width, height
	UIConfig:SetPoint("Right", UIParent, "CENTER",-200,100);
	--UIConfig.HeaderText:SetText("nae"); --trying to change the word Option on the title bar
	--	<KeyValue key="headerTextPadding" value="100" type="number"/>
	--	<KeyValue key="textString" value="UMENU" type="global"/>

	UIConfig.title = UIConfig:CreateFontString(nil, "OVERLAY");
	UIConfig.title:SetFontObject("GameFontHighlight");
	UIConfig.title:SetPoint("CENTER", UIConfig.TitleBg, "CENTER", 5, 0);
	UIConfig.title:SetText("Assistant |cFFFF0000[Red]|r");
	
	tinsert(UISpecialFrames, "AssistantRed") --used to close window with escape, chk name in create variables
	
	-- Movable
	UIConfig:SetMovable(true)
	UIConfig:SetClampedToScreen(true)
	UIConfig:SetScript("OnMouseDown", function(frame, button)
		if button == "LeftButton" then
			frame:StartMoving()
		end
	end)
	UIConfig:SetScript("OnMouseUp", UIConfig.StopMovingOrSizing)
	
	

	-------------------------
	--Buttons
	-------------------------
		--[[
	UIConfig.BBBtn = CreateFrame("Button", nil, UIParent, "GameMenuButtonTemplate");
	UIConfig.BBBtn:SetPoint("TOP", UIConfig, "TOP", 0, 0);
	UIConfig.BBBtn:SetSize(140, 30);
	UIConfig.BBBtn:SetText("Check");
	UIConfig.BBBtn:SetNormalFontObject("GameFontNormal");
	]]
	
	
	--UIConfig.TestBtn = self:CreateButton("TOP", loadBtn, "LEFT", 70, "TESTING..."); --not working
		
	--Button 1--	
	UIConfig.Btn1 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.Btn1:SetPoint("TOP", UIConfig, "TOP", 0, -40);
	UIConfig.Btn1:SetSize(140, 30);
	UIConfig.Btn1:SetText("Reset Data");
	--UIConfig.Btn1:SetNormalFontObject("GameFontNormal");
	UIConfig.Btn1:SetScript("OnClick", function()
		resetLoot()
		print ("Loot table has be reset")
		end)
	--UIConfig.Btn1:SetHighlightFontObject("GameFontHighlightSmall");

	--Button 2--
	UIConfig.Btn2 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.Btn2:SetPoint("TOP", UIConfig.Btn1, "BOTTOM", 0, -10);
	UIConfig.Btn2:SetSize(140, 30);
	UIConfig.Btn2:SetText("Show Shortcuts");
	--UIConfig.Btn2:SetNormalFontObject("GameFontNormalLarge");
	--UIConfig.Btn2:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.Btn2:SetScript("OnClick", function()
		core.commands.help()
		end)

	--Load --Tracker
	UIConfig.loadBtn = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.loadBtn:SetPoint("TOP", UIConfig.Btn2, "BOTTOM", 0, -10);
	UIConfig.loadBtn:SetSize(140, 30);
	UIConfig.loadBtn:SetText("Show Tracker");
	
	--UIConfig.loadBtn:SetScript("OnClick", function() Addon:SetLock(true)end)
	--UIConfig.loadBtn:SetNormalFontObject("GameFontWhite");
	--UIConfig.loadBtn:SetHighlightFontObject("GameFontWhite");
	UIConfig.loadBtn:SetScript("OnClick", function()	
		
		SlashCmdList.GET_LOOT()
		end)

--------------------Slider1
	UIConfig.slider1 = CreateFrame("Slider", nil, UIConfig, "OptionsSliderTemplate");
	UIConfig.slider1:SetPoint("TOP", UIConfig.loadBtn, "BOTTOM", 0, -50);
	UIConfig.slider1:SetValueStep(1);
	UIConfig.slider1:SetMinMaxValues(1, 5)
	UIConfig.slider1:SetValue(3); --default
	UIConfig.slider1:SetObeyStepOnDrag(true);
	UIConfig.slider1:SetScript("OnMouseUp", function()
		chkLimit = UIConfig.slider1:GetValue()
		UIConfig.editbox1:SetText(qualityNames[chkLimit])
		end)
	
	UIConfig.slider1desc = CreateFrame("EditBox", nil, UIConfig)
	UIConfig.slider1desc:SetWidth(100)
	UIConfig.slider1desc:SetMultiLine(true)
	UIConfig.slider1desc:Disable()
	UIConfig.slider1desc:SetPoint("BOTTOM", UIConfig.slider1, "TOP", -25, 10)
	UIConfig.slider1desc:SetJustifyH("LEFT");
	UIConfig.slider1desc:SetFontObject("ChatFontNormal")
	UIConfig.slider1desc:SetText("Set view limit")
		
	qualityNames = {"|cff9d9d9dVendor|r","Common","|cff1eff00Uncommon|r","|cff0070ddRare|r","|cffa335eeEpic|r"}
	
	UIConfig.editbox1 = CreateFrame("EditBox", nil, UIConfig)
	UIConfig.editbox1:SetWidth(100)
	UIConfig.editbox1:SetMultiLine(true)
	UIConfig.editbox1:Disable()
	UIConfig.editbox1:SetPoint("TOP", UIConfig.slider1, "BOTTOM", 0, -10)
	UIConfig.editbox1:SetJustifyH("MIDDLE");
	UIConfig.editbox1:SetFontObject("ChatFontNormal")
	UIConfig.editbox1:SetText(qualityNames[chkLimit])
---------------------------------------------------------------------------------	
	
	

--[[Dont need these from lessons
	-- Slider2
	UIConfig.slider2 = CreateFrame("Slider", nil, UIConfig, "OptionsSliderTemplate");
	UIConfig.slider2:SetPoint("TOP", UIConfig.slider1, "BOTTOM", 0, -20);
	UIConfig.slider2:SetValueStep(1);
	UIConfig.slider2:SetMinMaxValues(1, 5)
	UIConfig.slider2:SetValue(5); --default
	UIConfig.slider2:SetObeyStepOnDrag(true);
 

	-- Check Button1
	UIConfig.checkBtn1 = CreateFrame("CheckButton", nil, UIConfig, "UICheckButtonTemplate");
	UIConfig.checkBtn1:SetPoint("TOPLEFT", UIConfig.slider2, "BOTTOMLEFT", 0, -30); --trailing icon above it
	UIConfig.checkBtn1.text:SetText("A Check Button!");
	UIConfig.checkBtn1:SetChecked(true);
	-- Check Button2
	UIConfig.checkBtn2 = CreateFrame("CheckButton", nil, UIConfig, "UICheckButtonTemplate");
	UIConfig.checkBtn2:SetPoint("TOPLEFT", UIConfig.checkBtn1, "BOTTOMLEFT", 0, -10); --trailing icon above it
	UIConfig.checkBtn2.text:SetText("Another Check Button!");
	UIConfig.checkBtn2:SetChecked(true);
]]


	UIConfig:Hide();
	return UIConfig;
end

--[[for i=1,10,1 do
	print (i)
end]]


--[[
frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT");
frame:SetSize(200,500);
frame:SetScale(0.8);
frame:SetFrameLevel(20);
frame:SetFrameStrata("MEDIUM");]]

--[[Background, Border, Artwork, Overlay, Highlight]]
--core.Config.Toggle(); --Open on reload, doesnt work with esc key listed
--print ("...Loaded RedGUI!")
