-------------------------------------------------
--Generic Red settings
--Slash commands such as RL, RC, Red (help, menu),
--

local _, core = ...; -- Namespace


-------------------------
--Custom Slash Commands
-------------------------
core.commands = {
	["menu"] = core.Config.Toggle,
	
	["help"] = function()
		print(" ");
		print("List of slash commands for Assistant |cFFFF0000[Red]|r:");
		print("|cff00cc66/red|r - toggles the config window");
		print("|cff00cc66/red help|r - shows this help info");
		--print("|cff00cc66/red best|r - bonus feature");
		print("|cff00cc66/get|r - open the loot tracker");
		print("|cff00cc66/report|r - report all loot to console for debugging");
		print("|cff00cc66/limit|r - check current loot tracker limit for degugging");
		print("|cff00cc66/bags|r - report player's bags to editbox");
		print("|cff00cc66/rl|r - Reload UI |cff00cc66/rc|r - Ready Check");
		print(" ");
	end
	--[[
	["best"] = function()
		print(UnitName("player").." is the best!") --this didnt work as intended
	end]]
	
};

local function HandleSlashCommands(str)
	if (#str == 0) then
		core.commands.menu();
		return;
	end


	--lazy cut and paste from github... so it should work
	--still learning to comment so forgot what this was for
	--after alot of reading i figure it handles the slash command triggered by typing /red
	--looks like the first part identifys the space in the string and makes a new string of the command
	--it then appears to do magic, followed by what to do if the command does not exisit :(
	--i was hoping it did a sub command, but i dont understand it.
	local args = {};
	for _, arg in ipairs({ string.split(' ', str) }) do
		if (#arg > 0) then
			table.insert(args, arg);
		end
	end
	
	local path = core.commands; -- required for updating found table.
	
	for id, arg in ipairs(args) do
		if (#arg > 0) then -- if string length is greater than 0.
			arg = arg:lower();			
			if (path[arg]) then
				if (type(path[arg]) == "function") then				
					-- all remaining args passed to our function!
					path[arg](select(id + 1, unpack(args))); 
					return;					
				elseif (type(path[arg]) == "table") then				
					path = path[arg]; -- another sub-table found!
				end
			else
				-- does not exist!
				print("Slash command does not exist!");
				core.commands.help();
				return;
			end
		end
	end
	--end cut and paste^^


end

--For enabling left and right keys to move in the chat edit box
for i = 1, NUM_CHAT_WINDOWS do
	_G["ChatFrame"..i.."EditBox"]:SetAltArrowKeyMode(false);
end

-------------------------
--Register slash commands
-------------------------

-- Call addon
SLASH_AssistantRed1 = "/red";
SlashCmdList.AssistantRed = HandleSlashCommands; --core.Config.Toggle;


--SLASH_FRAMESTK1 = "/fs"; --slash command for showing framestack tool
--SlashCmdList.FRAMESTK = function()
--	LoadAddOn("Blizzard_DebugTools");
--	FrameStackTooltip_Toggle();
--end


-- For quicker reloading
SLASH_RELOADUI1 = "/rl"
SlashCmdList.RELOADUI = ReloadUI

-- Because im lazy
SLASH_READYCHECK1 = "/rc"
SlashCmdList.READYCHECK = DoReadyCheck


--Welcome note
--print ("...Loaded initialiser!")
print("Hey " .. UnitName("player") .. ", Assistant " .. "|cFFFF0000[Red]|r" .. " is operational. '/red'");

--core.commands.menu() load red menu on boot

