--This LUA identifies the item drop, adds it to the lootTable and provides report to console

lootTable = {}
local who, msg, quality = ...


function add()		
	z = {name=who, item=what, lvl=quality}		--capture loot data
	table.insert(lootTable,z)		--add everything to the table
end

function reportToConsole() --for debugging, slashcommand at bottom
	if #lootTable > 0 then
	print("#    ".." ".."Who           ".."Lv","What")				--table headers
	for i, z in ipairs(lootTable) do								--report all loot
		while z.name:len() < 14 do z.name= z.name.." " end
		if z.lvl > chkLimit-1 then
		print(string.format("%03d",i).." "..z.name.. z.lvl, z.item) --check the string format!
		end
	end
	else
	print ("Loot Table empty!")
	end
end


local EventFrame = CreateFrame("frame", "EventFrame")
EventFrame:RegisterEvent("CHAT_MSG_LOOT")

EventFrame:SetScript("OnEvent", function(self, event, ...)
	
		
	if(event == "CHAT_MSG_LOOT") then
		--local text, playerName2 = ... --i think this assigns args from chat_msg_loot, but i created new strings below
		local newLoot = {...};
		who = newLoot[5]; --playerName
		msg = newLoot[1]; --You receive loot:[item]
		
		--adding match to remove grouploot features
		--if string.match(msg, "recei") then
		
		what = msg:sub(string.find(newLoot[1],": ")+2,-2) --[item]
		local icolour = msg:sub(string.find(newLoot[1],": ")+3,string.find(newLoot[1],": ")+11) --find colour code in CHAT_MSG_LOOT
			
		----------------------------
		--Identify quality of item-- --might move this out as a function, might not
		----------------------------
		if (icolour == "cff9d9d9d") then --gray
			--print ("hello there!")
			quality = 1
		elseif (icolour == "cffffffff") then --white
			--print ("Whinning")
			quality = 2
		elseif (icolour == "cff1eff00") then -- green
			--print ("GREEEEEEEN")
			quality = 3
		elseif (icolour == "cff0070dd") then -- blue
			--print ("BB8!")
			quality = 4
		else
			print ("take a screenie " .. what .. " is " .. icolour) --capture purple
			quality = 5
		end
		
		add()
		
		if KethoEditBox2.Frame:IsVisible() then
		SlashCmdList.GET_LOOT()
		end -- allows user to hide list but updates when visable.
		
		--end -- string.match to hide group loot dice rolls...  annoying but colourful
		
	end
end)

function checkLootLimit()
print ("Loot level: "..chkLimit)
end
SLASH_GETLIMIT1 = "/limit"
SlashCmdList.GETLIMIT = checkLootLimit


SLASH_GETLOOTTABLE1 = "/report"
SlashCmdList.GETLOOTTABLE = reportToConsole


function resetLoot()
	for k in pairs (lootTable) do
    lootTable [k] = nil
end
SlashCmdList.GET_LOOT()
end
SLASH_RESET_LOOT1 = "/red reset"
SlashCmdList.RESET_LOOT = resetLoot




--print ("...Loaded lootTracker!")