--Thanks Ketho c 12 Oct 2019 Blizzard Forums
--trackerIsOpen = true

SLASH_GET_LOOT1 = "/get"
function SlashCmdList.GET_LOOT()
	KethoEditBox2:Show()
end
--[[
SLASH_GET_LOOT1 = "/get"
function KethoEditBox2:Toggle()
	local menu = UIConfig or KethoEditBox2.Create();
	menu:SetShown(not menu:IsShown());
end]]

KethoEditBox2 = {}

function KethoEditBox2:Create()
	local f = CreateFrame("Frame", "AssistantRedLootTrackerGUI", UIParent, "DialogBoxFrame")
	self.Frame = f
	f:SetPoint("LEFT",UIParent, "CENTER",200,100)
	f:SetSize(300, 500)

	f:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		edgeFile = "Interface\\PVPFrame\\UI-Character-PVP-Highlight", -- this one is neat
		edgeSize = 16,
		insets = { left = 8, right = 6, top = 8, bottom = 8 },
	})
	f:SetBackdropBorderColor(0, .44, .87, 0.5) -- darkblue

	tinsert(UISpecialFrames, "AssistantRedLootTrackerGUI") --used to close window with escape, chk name in create variables

	-- Movable
	f:SetMovable(true)
	f:SetClampedToScreen(true)
	f:SetScript("OnMouseDown", function(frame, button)
		if button == "LeftButton" then
			frame:StartMoving()
		end
	end)
	f:SetScript("OnMouseUp", f.StopMovingOrSizing)

	-- ScrollFrame
	local sf = CreateFrame("ScrollFrame", nil, f, "UIPanelScrollFrameTemplate")
	sf:SetPoint("LEFT", 16, 0)
	sf:SetPoint("RIGHT", -32, 0)
	sf:SetPoint("TOP", 0, -16)
	sf:SetPoint("BOTTOM", f, "BOTTOM", 0, 50)

	-- EditBox
	local eb = CreateFrame("EditBox", nil, sf)
	self.EditBox = eb
	eb:SetSize(sf:GetSize())
	eb:SetMultiLine(true)
	eb:SetAutoFocus(false) -- dont automatically focus
	eb:SetFontObject("ChatFontNormal")
	eb:SetScript("OnEscapePressed", eb.ClearFocus)
	sf:SetScrollChild(eb)
	
	-- Resizable
	f:SetResizable(true)
	f:SetMinResize(150, 100)
	local rb = CreateFrame("Button", nil, f)
	rb:SetPoint("BOTTOMRIGHT", -6, 7)
	rb:SetSize(16, 16)
	rb:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
	rb:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
	rb:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")

	rb:SetScript("OnMouseDown", function(frame, button)
		if button == "LeftButton" then
			f:StartSizing("BOTTOMRIGHT")
			frame:GetHighlightTexture():Hide() -- more noticeable
		end
	end)
	rb:SetScript("OnMouseUp", function(frame)
		f:StopMovingOrSizing()
		frame:GetHighlightTexture():Show()
		eb:SetWidth(sf:GetWidth())
	end)
end

function KethoEditBox2:Show()
	if not self.EditBox then
		self:Create()
	end
	
	self.EditBox:SetText("")
	
	for i, z in ipairs(lootTable) do
		if z.lvl > chkLimit-1 then
		while z.name:len() < 14 do z.name= z.name.." " end
		self.EditBox:Insert(z.name..'\t'..z.item.."\n") --removed the space .." ".. and added a tab to attempt better spacing and copy
		end
	end
	
	self.Frame:Show()
		
end





--print ("...Loaded lootTrackerGUI!")